/*********************************************************************
*			
*			Controlador para Cleopatra XS40 paralela (cleXS40p)
*
*			por: Daniel Carvalho Liedke			14/09/1999
*                                        atualizado:            15/09/1999  10:39a
*
*********************************************************************/

#include <stdio.h>
#include <dos.h>
#include <conio.h>

int pega_dado4(void);

unsigned char memoria[1024];

int main (int argc, char *argv[])
{
	int f,a,indice=0,fins=0;
	FILE *fp;

	if (argc!=2) return 1;
qqq:	goto qqq;
/*
	memoria[0]=0xAA;
	memoria[1]=0xBB;
	memoria[2]=0xCC;
	memoria[0xE]=0xFE;
	indice=0xfE-0xf0;
	goto aqui;
*/
	// Poe porta em estado conhecido
	_outp(0x378,0x0);

	// Reseta tudo
	_outp(0x378,0x2);_outp(0x378,0x0);
    //  delay(100);

	// Primeiro SPARE e padrao, libera a cleopatra
	_outp(0x378,0x1);_outp(0x378,0x0);

	// Polling esperando o fim do processamento da cleopatra
	for(;;)
	{
		a=pega_dado4();

		// Verifica se cleopatra ja terminou
		if (a==0xA)	break;

	}

      // Espera FPGA se estabilizar
   //   delay(200);

	for(;;)
	{
	  // 2x botao Spare, le 1 byte da memoria

  	     _outp(0x378,0x1);_outp(0x378,0x0);
           a=pega_dado4()*0x10;
           _outp(0x378,0x1);_outp(0x378,0x0);
           a=a+pega_dado4();

  	     memoria[indice]=a;
	     indice++;

		// Verifica se encontrou 255 bytes 0FFh, se achou para de ler a memria
  	     if (a==0xFF) fins++;
	     if (fins==255) {indice-=256;break;}

	}

	// Grava em um arquivo o conteudo da memria
aqui:

	fp=fopen(argv[1],"w");
	for (f=0;f<=indice;f++)
		fprintf(fp,"%d\n",memoria[f]);
	fclose(fp);

	return 0;
}

// Retorna o numero de 4 bits vindo do FPGA da XS40
// By: Daniel Carvalho Liedke!

int pega_dado4(void)
{
	unsigned char retorno,tmp[4];

    _asm
   {
	mov ah,2h
	mov dx,0h
	int 17h			// Pega o status da porta paralela

	mov tmp[0],ah
	not tmp[0]
	and tmp[0],8        // Bit 3 (invertido) (mais significativo)
	ror tmp[0],3
	mov tmp[1],ah
	and tmp[1],16
	ror tmp[1],4-1		 // Bit 4
	mov tmp[2],ah
	and tmp[2],32
	ror tmp[2],5-2		 // Bit 5
	mov tmp[3],ah
	not tmp[3]
	and tmp[3],64
	ror tmp[3],6-3      // Bit 6 (invertido) (menos significativo)

	mov ah,tmp[0]
	or ah,tmp[1]
	or ah,tmp[2]
	or ah,tmp[3]
	mov retorno,ah		// Retorna os 4 bits perfex
   }

   return (retorno);
}
